# coding: utf-8

"""
    FINTER API

    ## Finter API Document 1. Domain   - production      - https://api.finter.quantit.io/   - staging      - https://staging.api.finter.quantit.io/  2. Authorization <br><br/>(1) 토큰 발급<br/>curl -X POST https://api.finter.quantit.io/login -d {'username': '{finter_user_id}', 'password': '{finter_user_password}'<br> (2) username, password 로그인 (swagger ui 이용 시)<br/>  # noqa: E501

    OpenAPI spec version: 0.298
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six
from finter.api_client import ApiClient
from finter.rest import ApiException
from finter.settings import logger


class QuandaDataApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def quanda_data_get_file_retrieve(self, **kwargs):  # noqa: E501
        """quanda_data_get_file_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_get_file_retrieve(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str object_name:
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_get_file_retrieve_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.quanda_data_get_file_retrieve_with_http_info(**kwargs)  # noqa: E501
            return data

    def quanda_data_get_file_retrieve_with_http_info(self, **kwargs):
        all_params = [
            'object_name', 'bucket', 'personal',
            'async_req', '_return_http_data_only', '_preload_content', '_request_timeout'
        ]
        params = locals()
        for key, val in six.iteritems(kwargs):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_get_file_retrieve" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}
        path_params = {}
        query_params = []
        if 'object_name' in params:
            query_params.append(('object_name', params['object_name']))
        if 'bucket' in params:
            query_params.append(('bucket', params['bucket']))
        if 'personal' in params:
            query_params.append(('personal', params['personal']))
        header_params = {}
        form_params = []
        local_var_files = {}
        body_params = None

        # Try multiple Accept headers
        accept_headers = [
            'application/octet-stream',
            'application/json',
            '*/*'  # This accepts any content type
        ]

        response = None
        for accept in accept_headers:
            header_params['Accept'] = self.api_client.select_header_accept([accept])

            try:
                response = self.api_client.call_api(
                    '/quanda_data/get_file', 'GET',
                    {},  # path_params
                    query_params,
                    header_params,
                    response_type='file',
                    auth_settings=['basicAuth', 'tokenAuth'],
                    _preload_content=False,  # Always set to False to handle streaming ourselves
                    _request_timeout=kwargs.get('_request_timeout'),
                    _return_http_data_only=True
                )
                break  # If successful, break the loop
            except ApiException as e:
                if e.status != 406:  # If it's not a 406 error, re-raise it
                    raise
                logger.warning(f"Accept header {accept} not acceptable, trying next.")
                # If it's a 406 error, try the next Accept header
                continue

        if response is None:
            raise ApiException("Could not find an acceptable content type for the response")

        # Log response details for debugging
        logger.debug(f"Response headers: {response.headers}")
        logger.debug(f"Response content type: {response.headers.get('Content-Type')}")

        return response

    def quanda_data_get_retrieve(self, **kwargs):  # noqa: E501
        """quanda_data_get_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_get_retrieve(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool deserialize:
        :param str object_name:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_get_retrieve_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.quanda_data_get_retrieve_with_http_info(**kwargs)  # noqa: E501
            return data

    def quanda_data_get_retrieve_with_http_info(self, **kwargs):  # noqa: E501
        """quanda_data_get_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_get_retrieve_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool deserialize:
        :param str object_name:
        :param str bucket:
        :param bool personal:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deserialize', 'object_name', 'bucket', 'personal']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_get_retrieve" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'deserialize' in params:
            query_params.append(('deserialize', params['deserialize']))  # noqa: E501
        if 'object_name' in params:
            query_params.append(('object_name', params['object_name']))  # noqa: E501
        if 'bucket' in params:
            query_params.append(('bucket', params['bucket']))  # noqa: E501
        if 'personal' in params:
            query_params.append(('personal', params['personal'])) # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth', 'tokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/quanda_data/get', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def quanda_data_id_table_retrieve(self, **kwargs):  # noqa: E501
        """quanda_data_id_table_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_id_table_retrieve(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id_type:
        :param str vendor:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_id_table_retrieve_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.quanda_data_id_table_retrieve_with_http_info(**kwargs)  # noqa: E501
            return data

    def quanda_data_id_table_retrieve_with_http_info(self, **kwargs):  # noqa: E501
        """quanda_data_id_table_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_id_table_retrieve_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id_type:
        :param str vendor:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id_type', 'vendor']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_id_table_retrieve" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'id_type' in params:
            query_params.append(('id_type', params['id_type']))  # noqa: E501
        if 'vendor' in params:
            query_params.append(('vendor', params['vendor']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth', 'tokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/quanda_data/id_table', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def quanda_data_obj_list_retrieve(self, **kwargs):  # noqa: E501
        """quanda_data_obj_list_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_obj_list_retrieve(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str prefix:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_obj_list_retrieve_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.quanda_data_obj_list_retrieve_with_http_info(**kwargs)  # noqa: E501
            return data

    def quanda_data_obj_list_retrieve_with_http_info(self, **kwargs):  # noqa: E501
        """quanda_data_obj_list_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_obj_list_retrieve_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str prefix:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['prefix']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_obj_list_retrieve" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'prefix' in params:
            query_params.append(('prefix', params['prefix']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth', 'tokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/quanda_data/obj_list', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def quanda_data_upload_file_create(self, **kwargs):
        """quanda_data_upload_file_create  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_upload_file_create(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_upload_file_create_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.quanda_data_upload_file_create_with_http_info(**kwargs)  # noqa: E501
            return data

    def quanda_data_upload_file_create_with_http_info(self, **kwargs):
        """quanda_data_upload_file_create  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_upload_file_create(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str prefix:
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        all_params = ['file_path', 'personal']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_obj_list_retrieve" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'personal' in params:
            query_params.append(('personal', params['personal'])) # noqa: E501


        header_params = {}
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])

        form_params = []
        local_var_files = {}
        local_var_files['file_path'] = params['file_path']
        del params['file_path']

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth', 'tokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/quanda_data/upload_file', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def quanda_data_create(self, **kwargs):
        """quanda_data_create  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_create_with_http_info(async_req=True)
        >>> result = thread.get()

        :param json data
        :param str object_name:
        :param bool personal
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.quanda_data_create_with_http_info(**kwargs)
        else:
            (data) = self.quanda_data_create_with_http_info(**kwargs)
            return data

    def quanda_data_create_with_http_info(self, **kwargs):
        """quanda_data_create_with_http_info  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.quanda_data_create_with_http_info(async_req=True)
        >>> result = thread.get()

        :param json data
        :param str object_name:
        :param bool personal
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['object_name', 'data', 'personal']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method quanda_data_create_with_http_info" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []

        local_var_files = {}

        body_params = dict()
        if 'prefix' in params:
            body_params['prefix'] = params['prefix'] # noqa: E501
        if 'object_name' in params:
            body_params['object_name'] = params['object_name']
        if 'personal' in params:
            body_params['personal'] = params['personal']
        if 'data' in params:
            body_params['data'] = params['data']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth', 'tokenAuth']  # noqa: E501

        return self.api_client.call_api(
            '/quanda_data/put', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

